/*
	AppleTalk.h -- AppleTalk Manager
	
	C Interface to the Macintosh Libraries
	Copyright Apple Computer,Inc. 1985-1987
	All rights reserved.
*/

#ifndef __APPLETALK__
#define __APPLETALK__
#ifndef __TYPES__
#include <Types.h>
#endif

				/* AFPCall command codes */

#define afpByteRangeLock	1
#define afpVolClose			2
#define afpDirClose			3
#define afpForkClose		4
#define afpCopyFile			5
#define afpDirCreate		6
#define afpFileCreate		7
#define afpDelete			8
#define afpEnumerate		9
#define afpFlush			10
#define afpForkFlush		11
#define afpGetDirParms		12
#define afpGetFileParms		13
#define afpGetForkParms		14
#define afpGetSInfo			15
#define afpGetSParms		16
#define afpGetVolParms		17
#define afpLogin			18
#define afpContLogin		19
#define afpLogout			20
#define afpMapID			21
#define afpMapName			22
#define afpMove				23
#define afpOpenVol			24
#define afpOpenDir			25
#define afpOpenFork			26
#define afpRead				27
#define afpRename			28
#define afpSetDirParms		29
#define afpSetFileParms		30
#define afpSetForkParms		31
#define afpSetVolParms		32
#define afpWrite			33
#define afpGetFlDrParms		34
#define afpSetFlDrParms		35

#define afpDTOpen			48
#define afpDTClose			49
#define afpGetIcon			51
#define afpGtIcnInfo		52
#define afpAddAPPL			53
#define afpRmvAPPL			54
#define afpGetAPPL			55
#define afpAddCmt			56
#define afpRmvCmt			57
#define afpGetCmt			58

#define afpAddIcon			192			/* Special code for ASP Write commands */

				/* ASP miscellaneous */

#define xppLoadedBit		5				/* XPP bit in PortBUse */
#define xppUnitNum			40				/* Unit number for XPP (old ROMs) */
#define xppRefNum			-41				/* .XPP reference number */

#define scbMemSize			0xC0 			/* Size of memory for SCB */

#define xppFlagClr			0x00			/* constants for AFPCommandBlock */
#define xppFlagSet			0x80			/* StartEndFlag & NewLineFlag fields. */

#define lapSize 20
#define ddpSize 26
#define nbpSize 26
#define atpSize 56


enum {
	tLAPRead,tLAPWrite,tDDPRead,tDDPWrite,tNBPLookup,
	tNBPConfirm,tNBPRegister,tATPSndRequest,tATPGetRequest,
	tATPSdRsp,tATPAddRsp,tATPRequest,tATPResponse};
typedef unsigned char ABCallType;
enum {
	lapProto,ddpProto,nbpProto,atpProto};
typedef unsigned char ABProtoType;
typedef struct LAPAdrBlock {
	unsigned char dstNodeID,srcNodeID,lapProtType;
} LAPAdrBlock;
typedef struct AddrBlock {
	short aNet; unsigned char aNode,aSocket;
} AddrBlock;
typedef struct EntityName {
	String(32) objStr,typeStr,zoneStr;
} EntityName,*EntityPtr;
typedef struct RetransType {
	unsigned char retransInterval,retransCount;
} RetransType;
typedef char BitMapType;
typedef struct BDSElement {
	short buffSize;
	Ptr buffPtr;
	short dataSize;
	long userBytes;
} BDSElement,BDSType[8];
typedef BDSType *BDSPtr;
typedef struct ATLAPRec {
	ABCallType abOpcode;
	short abResult;
	long abUserReference;
	LAPAdrBlock lapAddress;
	short lapReqCount;
	short lapActCount;
	Ptr lapDataPtr;
} ATLAPRec,*ATLAPRecPtr,**ATLAPRecHandle;
typedef struct ATDDPRec {
	ABCallType abOpcode;
	short abResult;
	long abUserReference;
	short ddpType;
	short ddpSocket;
	AddrBlock ddpAddress;
	short ddpReqCount;
	short ddpActCount;
	Ptr ddpDataPtr;
	short ddpNodeID;
} ATDDPRec,*ATDDPRecPtr,**ATDDPRecHandle;
typedef struct ATNBPRec {
	ABCallType abOpcode;
	short abResult;
	long abUserReference;
	EntityPtr nbpEntityPtr;
	Ptr nbpBufPtr;
	short nbpBufSize;
	short nbpDataField;
	AddrBlock nbpAddress;
	RetransType nbpRetransmitInfo;
} ATNBPRec,*ATNBPRecPtr,**ATNBPRecHandle;
typedef struct ATATPRec {
	ABCallType abOpcode;
	short abResult;
	long abUserReference;
	short atpSocket;
	AddrBlock atpAddress;
	short atpReqCount;
	Ptr atpDataPtr;
	BDSPtr atpRspBDSPtr;
	BitMapType atpBitMap;
	short atpTransID;
	short atpActCount;
	long atpUserData;
	Boolean atpXO;
	Boolean atpEOM;
	short atpTimeOut;
	short atpRetries;
	short atpNumBufs;
	short atpNumRsp;
	short atpBDSSize;
	long atpRspUData;
	Ptr atpRspBuf;
	short atpRspSize;
} ATATPRec,*ATATPRecPtr,**ATATPRecHandle;


				/* structures for ASP & .XPP */

typedef struct 
{
	char		cmdByte;
	char		startEndFlag;
	short		forkRefNum;
	long		rwOffset;
	long		reqCount;
	char		newLineFlag;
	char		newLineChar;
} AFPCommandBlock;


#define XPPPBHeader \
	struct QElem	*qLink;			/* next queue entry */ \
	short			qType; 			/* queue type */ \
	short			ioTrap;			/* routine trap */ \
	Ptr				ioCmdAddr;		/* routine address */ \
	ProcPtr			ioCompletion;	/* completion routine */ \
	OSErr			ioResult;		/* result code */ \
	long			cmdResult;		/* Command result (ATP user bytes) */ \
	short			ioVRefNum;		/* volume reference or drive number */ \
	short			ioRefNum;		/* driver reference number ) */ \
	short			csCode			/* Call command code */

typedef struct 
{
	XPPPBHeader;			
	short		sessRefnum;		/* Offset to session refnum */
	char		aspTimeout;		/* Timeout for ATP */
	char		aspRetry;		/* Retry count for ATP */
	short		cbSize;			/* Command block size */
	Ptr			cbPtr;			/* Command block pointer */
	short		rbSize;			/* Reply buffer size */
	Ptr			rbPtr;			/* Reply buffer pointer */
	short		wdSize;			/* Write data size */
	Ptr			wdPtr;			/* Write data pointer */
	char		ccbStart[296];	/* CCB memory allocated for driver */
								/*afpWrite max size(CCB) = 296; all other calls = 150*/
} XPPPrmBlk;
	
typedef struct 
{
	XPPPBHeader;			
	short		sessRefnum;		/* Offset to session refnum */
	char		aspTimeout;		/* Timeout for ATP */
	char		aspRetry;		/* Retry count for ATP */
	short		cbSize;			/* Command block size */
	Ptr			cbPtr;			/* Command block pointer */
	short		rbSize;			/* Reply buffer size */
	Ptr			rbPtr;			/* Reply buffer pointer */
	AddrBlock	afpAddrBlock;	/* Address block in AFP login */
	Ptr			afpSCBPtr;		/* SCB pointer in AFP login */
	Ptr			afpAttnRoutine;	/* Attn routine pointer in AFP login */
	char		ccbFill[150-6];	/* CCB memory allocated for driver */
								/* Login needs only 150 bytes, BUT CCB really starts in the
								   middle of AFPSCBPtr and also clobbers AFPAttnRoutine. */
} AFPLoginPrm;
	
typedef struct 
{
	XPPPBHeader;			
	short		sessRefnum;		/* Offset to session refnum */
	char		aspTimeout;		/* Timeout for ATP */
	char		aspRetry;		/* Retry count for ATP */
	AddrBlock	serverAddr;		/* Server address block */
	Ptr			scbPointer;		/* SCB pointer */
	Ptr			attnRoutine;	/* Attention routine pointer */
} ASPOpenPrm, *ASPOpenPrmPtr;

typedef struct 
{
	XPPPBHeader;			
	Ptr			abortSCBPtr;	/* SCB pointer for AbortOS */
} ASPAbortPrm;

typedef struct 
{
	XPPPBHeader;			
	short		aspMaxCmdSize;	/* For SPGetParms */
	short		aspQuantumSize;
	short		numSesss;
} ASPGetparmsBlk;
	
typedef union 
{
	XPPPrmBlk 		XPP;
	ASPGetparmsBlk 	GETPARM;
	ASPAbortPrm 	ABORT;
	ASPOpenPrm 		OPEN;
	AFPLoginPrm 	LOGIN;
} XPPParamBlock, *XPPParmBlkPtr;

/*******************************************/
		/* MPP & ATP structures */

typedef struct
{
	short			entrylength;
	Ptr				entryPtr;
} wdselement;

typedef struct								/* returned by NBPLookup */
{
	AddrBlock		nteAddress;				/* network address of entity */
	char			filler;
	char			entityData[99];			/* Object, Type, & Zone */
} NTElement;

typedef struct								/* used for NBPRegister */
{
	Ptr				qNext;					/* ptr to next NTE */
	NTElement		nt;
} NamesTableEntry;

#define	MPPATPHeader	\
	struct QElem	*qLink;					/* next queue entry */ \
	short			qType; 					/* queue type */\
	short			ioTrap;					/* routine trap */\
	Ptr				ioCmdAddr;				/* routine address */ \
	ProcPtr			ioCompletion;			/* completion routine */\
	OSErr			ioResult;				/* result code */\
	long			userData;				/* Command result (ATP user bytes) */\
	short			reqTID;					/* request transaction ID */\
	short			ioRefNum;				/* driver reference number */\
	short			csCode;					/* Call command code */

typedef struct
{	
	MPPATPHeader
} MPPparms;

typedef struct
{
	MPPATPHeader
	char			protType;				/* ALAP protocol Type */
	char			filler;
	union
	{
		Ptr			wdsPointer;				/* -> write data structure */
		Ptr			handler;				/* -> protocol handler routine */
	} LAPptrs;
} LAPparms;

typedef struct
{
	MPPATPHeader
	char			socket;					/* socket number */
	char			checksumFlag;			/* check sum flag */
	union
	{
		Ptr			wdsPointer;				/* -> write data structure */
		Ptr			listener;				/* ->write data structure or -> Listener*/
	} DDPptrs;
} DDPparms;

typedef struct
{
	MPPATPHeader
	char			interval;				/* retry interval */
	char			count;					/* retry count */
	union
	{
		Ptr			ntQElPtr;				/* ->names table */
		Ptr			entityPtr;				/* ->entity name*/
	} NBPPtrs;
	union
	{
		char		verifyFlag;				/* set if verify needed */
		struct
		{
			Ptr		retBuffPtr;				/* ->return buffer */
			short	retBuffSize;			/* return buffer size */
			short	maxToGet;				/* matches to get */
			short	numGotten;				/* matches gotten */
		} Lookup;
		struct
		{
			AddrBlock	
					confirmAddr;			/* ->entity */
			char	newSocket;				/* socket number */
		} Confirm;
	} parm;
} NBPparms;

typedef struct
{
	MPPATPHeader
	char			newSelfFlag;			/* self-send toggle flag */
	char			oldSelfFlag;			/* previous self-send state */
} SetSelfparms;

typedef struct
{
	MPPATPHeader
	Ptr				nKillQEl;				/* ptr to i/o queue element to cancel */
} NBPKillparms;

typedef union								/* io param record for .MPP calls */
{
	MPPparms		MPP;					/* General MPP parms */
	LAPparms		LAP;					/* ALAP calls */
	DDPparms		DDP;					/* DDP calls */
	NBPparms		NBP;					/* NBP calls */
	SetSelfparms	SETSELF;	
	NBPKillparms	NBPKILL;				
} MPPParamBlock;

/* 	These #defines are provided to make life a little easier. The various
	parameter block field names are identical to those shown Inside MacIntosh
	(AppleTalk). They are prefixed with an appropriate driver function acronym
	so that these global symbols might not be duplicated. More of the same are
	provided for the ATP calls below.
	
	Given a variable:
	
	MPPParamBlock	Mpb;
	
	then:
	
	Mpb.MPPioResult = 0;
	
	clears the ioResult field. */
	
#define MPPioCompletion	MPP.ioCompletion		
#define MPPioResult		MPP.ioResult	
#define MPPioRefNum		MPP.ioRefNum		
#define MPPcsCode		MPP.csCode
#define LAPprotType		LAP.protType
#define LAPwdsPointer	LAP.LAPptrs.wdsPointer
#define LAPhandler		LAP.LAPptrs.handler
#define DDPsocket		DDP.socket
#define DDPchecksumFlag	DDP.checksumFlag
#define DDPwdsPointer	DDP.DDPptrs.wdsPointer
#define DDPlistener		DDP.DDPptrs.listener
#define	NBPinterval 	NBP.interval
#define NBPcount 		NBP.count
#define	NBPntQElPtr 	NBP.NBPPtrs.ntQElPtr
#define NBPentityPtr 	NBP.NBPPtrs.entityPtr
#define NBPverifyFlag 	NBP.parm.verifyFlag
#define NBPretBuffPtr 	NBP.parm.Lookup.retBuffPtr
#define NBPretBuffSize 	NBP.parm.Lookup.retBuffSize
#define NBPmaxToGet 	NBP.parm.Lookup.maxToGet
#define NBPnumGotten 	NBP.parm.Lookup.numGotten
#define NBPconfirmAddr 	NBP.parm.Confirm.confirmAddr
#define NBPnewSocket 	NBP.parm.Confirm.newSocket
#define NBPnKillQEl		NBPKILL.nKillQEl

typedef MPPParamBlock	*mppPBptr;

#define MOREATPHeader	\
	char			atpSocket;				/* currbitmap for requests */\
											/* or ATP socket number */\
	char			atpFlags;				/* control information */\
	AddrBlock		addrBlock;				/* source/dest. socket address */\
	short			reqLength;				/* request/response length */\
	Ptr				reqPointer;				/* ->request/response data */\
	Ptr				bdsPointer;				/* ->response BDS */
	
typedef struct
{
	MPPATPHeader
	MOREATPHeader
} ATPparms;

typedef struct
{
	MPPATPHeader
	MOREATPHeader
	char			filler;					/* numOfBuffs */
	char			timeOutVal;				/* timeout interval */
	char			numOfResps;				/* number of responses actually received */
	char			retryCount;				/* number of retries */
	short			intBuff;				/* used internally for NSendRequest */
} SendReqparms;

typedef struct
{
	MPPATPHeader
	MOREATPHeader
	union
	{
		char		bitMap;					/* bitmap received */
		char		numOfBuffs;				/* number of responses being sent */
		char		rspNum;					/* sequence number */
	} u0;
} ATPmisc1;

typedef struct
{
	MPPATPHeader
	MOREATPHeader
	char			filler;
	char			bdsSize;				/* number of BDS elements */
	short			transID;				/* transaction ID recd. */
} ATPmisc2;


typedef struct
{
	MPPATPHeader
	MOREATPHeader
	Ptr				aKillQEl;				/* ptr to i/o queue element to cancel */	
} Killparms;

typedef union								/* io param record for .ATP calls */
{
	ATPparms		ATP;					/* General ATP parms */
	SendReqparms	SREQ;					/* sendrequest parms */
	ATPmisc1		OTH1;					/* and a few others */
	ATPmisc2		OTH2;					/* and a few others */
	Killparms		KILL;					/* and a few others */
} ATPParamBlock;

#define ATPioCompletion	ATP.ioCompletion		
#define ATPioResult		ATP.ioResult		
#define ATPuserData		ATP.userData		
#define ATPreqTID		ATP.reqTID		
#define ATPioRefNum		ATP.ioRefNum		
#define ATPcsCode		ATP.csCode		
#define ATPatpSocket	ATP.atpSocket		
#define ATPatpFlags		ATP.atpFlags		
#define ATPaddrBlock	ATP.addrBlock		
#define ATPreqLength	ATP.reqLength		
#define ATPreqPointer	ATP.reqPointer		
#define ATPbdsPointer	ATP.bdsPointer	
#define ATPtimeOutVal	SREQ.timeOutVal
#define ATPnumOfResps	SREQ.numOfResps
#define ATPretryCount	SREQ.retryCount
#define ATPnumOfBuffs	OTH1.u0.numOfBuffs
#define ATPbitMap		OTH1.u0.bitMap
#define ATPrspNum		OTH1.u0.rspNum
#define ATPbdsSize		OTH2.bdsSize
#define ATPtransID		OTH2.transID
#define ATPaKillQEl		KILL.aKillQEl

#define atpXOvalue			32				/* ATP exactly-once bit */
#define atpEOMvalue			16				/* ATP End-Of-Message bit */
#define atpSTSvalue			8				/* ATP Send-Transmission-Status bit */
#define atpTIDValidvalue	2				/* ATP trans. ID valid bit */
#define atpSendChkvalue		1				/* ATP send checksum bit */

typedef ATPParamBlock	*atpPBptr;



/****************************************************************************/
/*																			*/
/*						PREFERRED APPLETALK CALLS							*/
/*																			*/
/****************************************************************************/

	/* .XPP Calls */
		
pascal OSErr OpenXPP(xppRefnum)
	short *xppRefnum;
	extern;

pascal OSErr ASPOpenSession(thePBptr, async)
	ASPOpenPrmPtr thePBptr;
	Boolean async;
	extern;

pascal OSErr ASPCloseSession(thePBptr, async)
	XPPParmBlkPtr thePBptr;
	Boolean async;
	extern;

pascal OSErr ASPAbortOS(thePBptr, async)
	XPPParmBlkPtr thePBptr;
	Boolean async;
	extern;

pascal OSErr ASPGetParms(thePBptr, async)
	XPPParmBlkPtr thePBptr;
	Boolean async;
	extern;

pascal OSErr ASPCloseAll(thePBptr, async)
	XPPParmBlkPtr thePBptr;
	Boolean async;
	extern;

pascal OSErr ASPUserWrite(thePBptr, async)
	XPPParmBlkPtr thePBptr;
	Boolean async;
	extern;

pascal OSErr ASPUserCommand(thePBptr, async)
	XPPParmBlkPtr thePBptr;
	Boolean async;
	extern;

pascal OSErr ASPGetStatus(thePBptr, async)
	XPPParmBlkPtr thePBptr;
	Boolean async;
	extern;

pascal OSErr AFPCommand(thePBptr, async)
	XPPParmBlkPtr thePBptr;
	Boolean async;
	extern;

/*******************************************/
		/* .MPP Calls */
		
pascal OSErr PAttachPH(thePBptr,async)
	mppPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PDetachPH(thePBptr,async)
	mppPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PWriteLAP(thePBptr,async)
	mppPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr POpenSkt(thePBptr,async)
	mppPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PCloseSkt(thePBptr,async)
	mppPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PWriteDDP(thePBptr,async)
	mppPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PRegisterName(thePBptr,async)
	mppPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PLookupName(thePBptr,async)
	mppPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PConfirmName(thePBptr,async)
	mppPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PRemoveName(thePBptr,async)
	mppPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PSetSelfSend(thePBptr,async)
	mppPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PKillNBP(thePBptr,async)
	mppPBptr	thePBptr;
	Boolean		async;
	extern;
	
/*******************************************/
		/* .ATP Calls */
		
pascal OSErr POpenATPSkt(thePBptr,async)
	atpPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PCloseATPSkt(thePBptr,async)
	atpPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PSendRequest(thePBptr,async)
	atpPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PGetRequest(thePBptr,async)
	atpPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PSendResponse(thePBptr,async)
	atpPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PAddResponse(thePBptr,async)
	atpPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PRelTCB(thePBptr,async)
	atpPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PRelRspCB(thePBptr,async)
	atpPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PNSendRequest(thePBptr,async)
	atpPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PKillSendReq(thePBptr,async)
	atpPBptr	thePBptr;
	Boolean		async;
	extern;
	
pascal OSErr PKillGetReq(thePBptr,async)
	atpPBptr	thePBptr;
	Boolean		async;
	extern;

/*******************************************/
		/*	Misc. Calls */
		
pascal void BuildLAPwds(wdsPtr,dataPtr,destHost,prototype,frameLen)
	Ptr			wdsPtr,dataPtr;
	short		destHost,prototype,frameLen;
	extern;
	
pascal void BuildDDPwds(wdsPtr,headerPtr,dataPtr,
						destAddress,ddpType,dataLen)
	Ptr			wdsPtr,headerPtr,dataPtr;
	AddrBlock	destAddress;
	short		ddpType,dataLen;
	extern;
	
pascal void NBPSetEntity(Buffer,NBPObject,NBPType,NBPZone)
	Ptr			Buffer;
	Ptr			NBPObject,NBPType,NBPZone;				/* PASCAL STRINGS */
	extern;
	
pascal void NBPSetNTE(NTEptr,NBPObject,NBPType,NBPZone,Socket)
	Ptr			NTEptr;
	Ptr			NBPObject,NBPType,NBPZone;				/* PASCAL STRINGS */
	short		Socket;
	extern;
	
pascal short GetBridgeAddress()
	extern;
	
pascal short BuildBDS(BuffPtr,BDSptr,BuffSize)
	Ptr			BuffPtr,BDSptr;
	short		BuffSize;
	extern;
	

/****************************************************************************/
/*																			*/
/*						ALTERNATE APPLETALK CALLS							*/
/*																			*/
/****************************************************************************/

pascal short MPPOpen()
	extern;
pascal short MPPClose()
	extern;
pascal short LAPOpenProtocol(theLAPType,protoPtr)
	short theLAPType;
	Ptr protoPtr;
	extern;
pascal short LAPCloseProtocol(theLAPType)
	short theLAPType;
	extern;
pascal short LAPWrite(abRecord,async)
	ATLAPRecHandle abRecord;
	Boolean async;
	extern;
pascal short LAPRead(abRecord,async)
	ATLAPRecHandle abRecord;
	Boolean async;
	extern;
pascal short LAPRdCancel(abRecord)
	ATLAPRecHandle abRecord;
	extern;
pascal short DDPOpenSocket(theSocket,sktListener)
	short *theSocket;
	Ptr sktListener;
	extern;
pascal short DDPCloseSocket(theSocket)
	short theSocket;
	extern;
pascal short DDPRead(abRecord,retCksumErrs,async)
	ATDDPRecHandle abRecord;
	Boolean retCksumErrs;
	Boolean async;
	extern;
pascal short DDPWrite(abRecord,doChecksum,async)
	ATDDPRecHandle abRecord;
	Boolean doChecksum;
	Boolean async;
	extern;
pascal short DDPRdCancel(abRecord)
	ATDDPRecHandle abRecord;
	extern;
pascal short ATPLoad() extern;
pascal short ATPUnload() extern;
pascal short ATPOpenSocket(addrRcvd,atpSocket)
	AddrBlock addrRcvd;
	short *atpSocket;
	extern;
pascal short ATPCloseSocket(atpSocket)
	short atpSocket;
	extern;
pascal short ATPSndRequest(abRecord,async)
	ATATPRecHandle abRecord;
	Boolean async;
	extern;
pascal short ATPRequest(abRecord,async)
	ATATPRecHandle abRecord;
	Boolean async;
	extern;
pascal short ATPReqCancel(abRecord,async)
	ATATPRecHandle abRecord;
	Boolean async;
	extern;
pascal short ATPGetRequest(abRecord,async)
	ATATPRecHandle abRecord;
	Boolean async;
	extern;
pascal short ATPSndRsp(abRecord,async)
	ATATPRecHandle abRecord;
	Boolean async;
	extern;
pascal short ATPAddRsp(abRecord)
	ATATPRecHandle abRecord;
	extern;
pascal short ATPResponse(abRecord,async)
	ATATPRecHandle abRecord;
	Boolean async;
	extern;
pascal short ATPRspCancel(abRecord,async)
	ATATPRecHandle abRecord;
	Boolean async;
	extern;
pascal short NBPRegister(abRecord,async)
	ATNBPRecHandle abRecord;
	Boolean async;
	extern;
pascal short NBPLookup(abRecord,async)
	ATNBPRecHandle abRecord;
	Boolean async;
	extern;
pascal short NBPExtract(theBuffer,numInBuf,whichOne,abEntity,address)
	Ptr theBuffer;
	short numInBuf;
	short whichOne;
	EntityName *abEntity;
	AddrBlock *address;
	extern;
pascal short NBPConfirm(abRecord,async)
	ATNBPRecHandle abRecord;
	Boolean async;
	extern;
pascal short NBPRemove(abEntity)
	EntityPtr abEntity;
	extern;
pascal short NBPLoad()
	extern;
pascal short NBPUnload()
	extern;
pascal void RemoveHdlBlocks()
	extern;
pascal short GetNodeAddress(myNode,myNet)
	short *myNode,*myNet;
	extern;
pascal Boolean IsMPPOpen() extern;
pascal Boolean IsATPOpen() extern;

#endif
